#ifndef BLE_CENTRAL_SCAN_H
#define BLE_CENTRAL_SCAN_H

/**@file
 * @
 */

#ifdef __cplusplus
extern "C" {
#endif

#include <zephyr/types.h>
#include <stddef.h>
#include <errno.h>
#include <zephyr/kernel.h>
#include <zephyr/sys/printk.h>

#include <zephyr/bluetooth/bluetooth.h>
#include <zephyr/bluetooth/hci.h>
#include <zephyr/bluetooth/conn.h>
#include <zephyr/bluetooth/uuid.h>
#include <zephyr/bluetooth/gatt.h>
#include <zephyr/sys/byteorder.h>

#include <zephyr/logging/log.h>

/******** The UUIDS we'll be connecting to, this is only for testing *******************/
/** the service we are looking to connect to ***/
#define BT_UUID_TEMPSENSOR_VAL	0x1520
#define BT_UUID_TEMPSENSOR           BT_UUID_DECLARE_16(BT_UUID_TEMPSENSOR_VAL)


	/** its characteristic ******/
#define BT_UUID_TEMPSENSOR_READ_VAL 	0x1521
#define BT_UUID_TEMPSENSOR_READ   BT_UUID_DECLARE_16(BT_UUID_TEMPSENSOR_READ_VAL)
/**************/

extern struct bt_conn *default_conn;
extern struct bt_uuid_16 discover_uuid;
extern struct bt_gatt_discover_params discover_params;
extern struct bt_gatt_subscribe_params subscribe_params;

bool target_found(struct bt_data *data, void *user_data);
uint8_t discover_func(struct bt_conn *conn, const struct bt_gatt_attr *attr, struct bt_gatt_discover_params *params);
void start_scan(void);
void device_found(const bt_addr_le_t *addr, int8_t rssi, uint8_t type, struct net_buf_simple *ad);
void device_connected(struct bt_conn *conn, uint8_t err);
void device_disconnected(struct bt_conn *conn, uint8_t reason);

BT_CONN_CB_DEFINE(conn_callbacks) = {
	.connected = device_connected,
	.disconnected = device_disconnected,
};


#ifdef __cplusplus
}
#endif

/**
 * @}
 */

#endif 
